<?
  require_once("comm_fns.php");


function valid_login($login)
{
  global $MAX_LOGIN_LEN;
  return ereg("^[a-zA-Z0-9]+$", $login) 
      && strlen($login) <= $MAX_LOGIN_LEN;
}


function valid_passwd($passwd)
{
  global $MIN_PASSWD_LEN, $MAX_PASSWD_LEN;
  return ereg("^[a-zA-Z0-9_\.\-\ ]+$", $passwd) 
      && strlen($passwd) >= $MIN_PASSWD_LEN  
      && strlen($passwd) <= $MAX_PASSWD_LEN;
}


function valid_filename($filename)
{
  global $MAX_FILENAME_LEN;
  return ereg("^[a-zA-Z0-9_\.\-]+$", $filename)
      && strlen($filename) <= $MAX_FILENAME_LEN; 
}


function valid_email($email)
{
  global $MAX_EMAIL_LEN;
  return ereg("^[a-zA-Z0-9_\.\-]+@[a-zA-Z0-9\-]+\.[a-zA-Z0-9\-\.]+$", $email)
      && strlen($email) <= $MAX_EMAIL_LEN; 
}


function valid_email_test($email)
{
  $email = explode("@", $email);
  return getmxrr($email[1], $aux);
//  return true;  
}


function valid_empty_name($name, $max)
{
  return strlen($name)<=$max && !strstr($name,'"') && !strstr($name,'<');
}


function valid_name($name, $max)
{
  return $name && valid_empty_name($name, $max);
}


function valid_icq($icq) 
{
  global $MAX_ICQ_LEN;
  return ereg("^[0-9]*$", $icq) && strlen($icq) <= $MAX_ICQ_LEN; 

}


function valid_state($state) 
{
  global $MAX_STATE_VALUE;
  return ereg("^[0-". ($MAX_STATE_VALUE-1) ."]$", $state); 
}



function valid_date(&$date) 
{
  return ereg("^2[0-9][0-9][0-9]\-[0-1][0-9]\-[0-3][0-9]$", $date);
}

function valid_date_test($date) 
{
 $yyyy = substr($date,0,4);
 $mm   = substr($date,5,2);
 $dd   = substr($date,8,2);
 return checkdate($mm, $dd , $yyyy);
}


function valid_auth(&$data)
{
  global $E_MSG;
  return (isset($data["login"])  && valid_login($data["login"]) &&
          isset($data["passwd"]) && valid_passwd($data["passwd"])) ?
         "" : $E_MSG["auth"];
}


function valid_setting(&$data) // overi nastaveni, ponecha vyhovujici hodnoty
{
  global $passwd0, $passwd1, $passwd2, $name, $email, $icq, 
         $E_MSG, $MAX_NAME_LEN;
	 
  if( !isset($data["passwd0"]) || !valid_passwd($data["passwd0"])
   || !isset($data["passwd1"]) || !valid_passwd($data["passwd1"])
   || !isset($data["passwd2"]) || !valid_passwd($data["passwd2"])) {
     $err.= "<br/>".$E_MSG["passwdf"];
     $passwd0 = $passwd1= $passwd2 = "";
  }
  if ($passwd1 != $passwd2) {
     $err.= "<br/>".$E_MSG["passwdd"];
     $passwd1 = $passwd2 = "";
  } 
  if(!isset($data["name"]) || !valid_name($data["name"], $MAX_NAME_LEN)) {
    $err.= "<br/>".$E_MSG["name"];
    $name="";
  }
  if(!isset($data["email"]) || !valid_email($data["email"])) {
    $err.= "<br/>".$E_MSG["emailf"];
    $email="";
  }
  else if (!valid_email_test($email))
    $err.= "<br/>".$E_MSG["emailt"];
    
  if(!isset($data["icq"]) || !valid_icq($data["icq"])) {
    $err.= "<br/>".$E_MSG["icq"];
    $icq="";
  }
  return substr($err, 5);
}


function valid_session(&$data) // overi zapis z jednani, ponecha vyhovujici hodnoty
{
  global $E_MSG, $MAX_SUBJECT_LEN, $date, $subject, $result;
  
  if(!isset($data["date"]) || !valid_date($data["date"])) {
     $err.= "<br/>".$E_MSG["datef"];
     $date="";
  }
  else if (!valid_date_test($date)) 
    $err.= "<br/>".$E_MSG["datet"];

  if(!isset($data["subject"]) || !valid_name($data["subject"], $MAX_SUBJECT_LEN)) {
    $err.= "<br/>".$E_MSG["subject"];
    $subject="";
  }
  if(!isset($data["result"]) || !$result)
    $err.= "<br/>".$E_MSG["result"];
 
  return substr($err, 5);
}


function valid_project(&$data) // overi soucast projektu, ponecha vyhovujici hodnoty
{
  global $E_MSG, $MAX_PROJECT_LEN, $name, $deadline, $state;
  
  if(!isset($data["name"]) || !valid_name($data["name"], $MAX_PROJECT_LEN)) {
    $err.= "<br/>".$E_MSG["proj"];
    $name="";
  }

  if(!isset($data["deadline"]) || !valid_date($data["deadline"])) {
     $err.= "<br/>".$E_MSG["datef"];
     $deadline="";
  }
  else if (!valid_date_test($deadline)) 
    $err.= "<br/>".$E_MSG["datet"];

  if(!isset($data["state"]) || !valid_state($data["state"])) {
    $err.= "<br/>".$E_MSG["state"];
    $state="";
  }
  return substr($err, 5);
}


function valid_news(&$data) // overi aktualitu, ponecha vyhovujici hodnoty
{
  global $E_MSG, $MAX_TITLE_LEN, $date, $title, $msg;
  
  if(!isset($data["date"]) || !valid_date($data["date"])) {
     $err.= "<br/>".$E_MSG["datef"];
     $date="";
  }
  else if (!valid_date_test($date)) 
    $err.= "<br/>".$E_MSG["datet"];

  if(!isset($data["title"]) || !valid_name($data["title"], $MAX_TITLE_LEN)) {
    $err.= "<br/>".$E_MSG["title"];
    $title="";
  }

  if(!isset($data["msg"]) || !$msg)
    $err.= "<br/>".$E_MSG["msg"];

  return substr($err, 5);
}


function valid_forum(&$data) // overi prispevek fora, ponecha vyhovujici hodnoty
{
  global $E_MSG, $MAX_TITLE_LEN, $title, $msg;
  
  if(!isset($data["title"]) || !valid_name($data["title"], $MAX_TITLE_LEN)) {
    $err.= "<br/>".$E_MSG["title"];
    $title="";
  }

  if(!isset($data["msg"]) || !$msg)
    $err.= "<br/>".$E_MSG["msg"];

  return substr($err, 5);
}


function valid_files(&$data) // overi soucast projektu, ponecha vyhovujici hodnoty
{
  global $E_MSG, $MAX_TITLE_LEN, $MAX_FILE_SIZE,
         $id, $srcfile, $srcfile_size, $file, $title, $text;
  
  if($id=="null")  {
  
    if($srcfile=="none" || !$srcfile_size)
      $err.= "<br/>".$E_MSG["fnone"];

    if($srcfile_size > $MAX_FILE_SIZE)
      $err.= "<br/>".$E_MSG["fattack"];

    if(!isset($data["file"]) || !valid_filename($data["file"])) {
      $err.= "<br/>".$E_MSG["fname"];
      $file="";
    }
  }

  if(!isset($data["title"]) || !valid_name($data["title"], $MAX_TITLE_LEN)) {
    $err.= "<br/>".$E_MSG["ftitle"];
    $title="";
  }

  if(!isset($data["text"]) || !$text)
    $err.= "<br/>".$E_MSG["ftext"];
  
  return substr($err, 5);
}

?>
